#include <mem.h>
#include <alloc.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "svga24.h"
#include "mys.h"
#include "keyb.h"
#include "3d.h"

#define POC 1600
#define POCS 40
#define POC1 10
#define MAXX 320
#define MAXY 80
#define VMEMSEG 0xA0000000L

struct bodn {
  int x, y, z;
};

struct vektorn {
  int x, y, z;
};

struct poly4 {
  bodn A;
  vektorn u, v;
  unsigned char color;
};

void polyf(poly4 p, bod A[], int odx, int ody) {
  tip vv, zoom = 1;
  int i = 0, j = 0;
  vektor uj, vj;
  vv = sqrt(p.u.x*p.u.x + p.u.y*p.u.y + p.u.z*p.u.z);
  uj.x = p.u.x/vv*zoom;
  uj.y = p.u.y/vv*zoom;
  uj.z = p.u.z/vv*zoom;
  vv = sqrt(p.v.x*p.v.x + p.v.y*p.v.y + p.v.z*p.v.z);
  vj.x = p.v.x/vv*zoom;
  vj.y = p.v.y/vv*zoom;
  vj.z = p.v.z/vv*zoom;
  for (i = 0 ; i < POCS; i ++) {
	for (j = 0; j < POCS; j ++) {
	  A[i + j*POCS].x = p.A.x + uj.x*(i+odx) + vj.x*(j+ody);
	  A[i + j*POCS].y = p.A.y + uj.y*(i+odx) + vj.y*(j+ody);
	  A[i + j*POCS].z = p.A.z + uj.z*(i+odx) + vj.z*(j+ody);
	}
  }
}

void koule(int poc, bod A[]) {
  int i = 0, j = 0;
  tip t = 0, s = 0;
  for (i = 0; i < poc; i++) {
	A[i].x = cos(s)*sqrt(10*10-(10-t)*(10-t)) + 30;
	A[i].y = sin(s)*sqrt(10*10-(10-t)*(10-t)) - 50;
	A[i].z = t;
	s += 0.157;
	j ++;
	if (j == 40) {
	  j = 0;
	  s = 0;
	  t += 0.5;
	}
  }
}

void recomp(int poc, bod A[], tip anim)
{
	int i = 0, j = 0;
	tip t = 0, s = 0, r;
	for (i = 0; i<poc; i++) {
	  A[i].x = t*10;
	  r = sqrt((s-2)*(s-2)+(t-2)*(t-2));
	  A[i].z = sin(r*5-anim)*2;
	  A[i].y = s*10+10;
	  t += 0.1;
	  j ++;
	  if (j==40) {
		j = 0;
		t = 0;
		s += 0.1;
	  }
	}
}

void main(void) {
unsigned char far *vmem = (unsigned char far *)VMEMSEG;

bod A[POC];
obod O[POC];  // pomocny bod
poly4 ctvr[POC1];

tip d = 500;
tip anim = 0;  //anim - hodnota animace
unsigned int i = 0, j = 0, k = 0, l = 0;  // pomocne promenne do ciklu
int gx, gy, gz, gc;
randomize();
for (j = 0; j < POC1; j ++) {
  ctvr[j].A.x = random(20)-10;
  ctvr[j].A.y = random(20)-10;
  ctvr[j].A.z = random(20)-10;
  ctvr[j].u.x = random(20)-10;
  ctvr[j].u.y = random(20)-10;
  ctvr[j].u.z = random(20)-10;
  ctvr[j].v.x = random(20)-10;
  ctvr[j].v.y = random(20)-10;
  ctvr[j].v.z = random(20)-10;
  ctvr[j].color = random(254)+1;
}
  i = 20;
  j = 0;
  ctvr[j].A.x = i;   ctvr[j].A.y = i;   ctvr[j].A.z = -i;
  ctvr[j].u.x = 0;   ctvr[j].u.y = -i;  ctvr[j].u.z = 0;
  ctvr[j].v.x = -i;  ctvr[j].v.y = 0;   ctvr[j].v.z = 0;
  j ++;
  ctvr[j].A.x = i;   ctvr[j].A.y = -i;  ctvr[j].A.z = -i;
  ctvr[j].u.x = 0;   ctvr[j].u.y = 0;   ctvr[j].u.z = i;
  ctvr[j].v.x = -i;  ctvr[j].v.y = 0;   ctvr[j].v.z = 0;
  j ++;
  ctvr[j].A.x = i;   ctvr[j].A.y = i;   ctvr[j].A.z = -i;
  ctvr[j].u.x = 0;   ctvr[j].u.y = -i;  ctvr[j].u.z = 0;
  ctvr[j].v.x = 0;   ctvr[j].v.y = 0;   ctvr[j].v.z = i;
  j ++;
  ctvr[j].A.x = -i;  ctvr[j].A.y = i;   ctvr[j].A.z = -i;
  ctvr[j].u.x = 0;   ctvr[j].u.y = -i;  ctvr[j].u.z = 0;
  ctvr[j].v.x = 0;   ctvr[j].v.y = 0;   ctvr[j].v.z = i;
  j ++;
  ctvr[j].A.x = i;   ctvr[j].A.y = i;   ctvr[j].A.z = -i;
  ctvr[j].u.x = 0;   ctvr[j].u.y = 0;   ctvr[j].u.z = i;
  ctvr[j].v.x = -i;  ctvr[j].v.y = 0;   ctvr[j].v.z = 0;
  j ++;
  ctvr[j].A.x = i;   ctvr[j].A.y = i;   ctvr[j].A.z = i;
  ctvr[j].u.x = 0;   ctvr[j].u.y = -i;  ctvr[j].u.z = 0;
  ctvr[j].v.x = -i;  ctvr[j].v.y = 0;   ctvr[j].v.z = 0;

mouse mys;
keyb key;
trote kamera;

unsigned char* vcon;

vcon =(unsigned char*) malloc(sizeof(unsigned char)*MAXX*MAXY);
if (vcon == NULL) {
  modvga(0x3);
  printf("Malo pameti\n");
  exit (1);
}

for (i = 0; i < 64000; i ++) {
  vmem[i] = 0;
}
for (i = 0; i < MAXX*MAXY; i ++) {
  vcon[i] = 0;
}

modvga(0x13);

for(i = 1; i < 256; i ++) {
  setpal6(256-i, i/4, 0, 20);
}

recomp(POC, A, anim);
mys.set_off();
kamera.set(0, 0, 0, 0, 0, 130);

const stredx = int(MAXX/2);
const stredy = int(MAXY/2);

startscan();
char c='/n';
while(c!='q') {
  for (j = 0; j < POC1 + 2; j ++) {
	  if (j < POC1) {
		polyf(ctvr[j], A, k*20, l*20);
		gc = ctvr[j].color;
	  }
	  if (j == POC1) {
		recomp(POC, A, anim);
		gc = 11;
	  }
	  if (j == POC1+1) {
		koule(POC, A);
		gc = 14;
	  }
	  prumet(A, O, kamera.B, kamera.up, kamera.vp, d, 0, POC);
	  for (i = 0; i < POC; i ++) {
		gz = O[i].z*1.5;
		if ((gz > 0)&&(gz < 256)) {
		  gx = stredx + O[i].x;
		  gy = stredy - O[i].y;
		  if ( (gx < MAXX)&&(gy < MAXY)&&(gx > 0)&&(gy > 0) ) {
			if ((vcon[gx + gy*320] > gz)||(vcon[gx + gy*320] == 0)) {
			  vcon[gx + gy*320] = gz;
//			  vmem[gx + gy*320] = gc;
			}
		  }
		}
	  }
  }
  movedata(FP_SEG(vcon), FP_OFF(vcon), FP_SEG(vmem), FP_OFF(vmem), MAXX*MAXY);
/*
  for (i = 0; i < MAXX*MAXY; i ++) {
	if (vcon[i] == 0) vmem[i] = 0;
  }
*/
  for (i = 0; i < MAXX*MAXY; i ++) {
	vcon[i] = 0;
  }

//  delay(10);
  anim += 0.1;
  mys.move();
//  while (!mys.move()&&!kbhit());

  c = '/n';
  if (kbhit()) c = getch();
  if (c==0) c = getch();
  key.clear();
  kamera.rotate(-mys.get_relativex()*0.003);
  kamera.look(-mys.get_relativey()*0.003);

  if (keys[72].pressed) kamera.step(10);
  if (keys[80].pressed) kamera.step(-10);
  if (keys[22].pressed) d = d + 10;
  if (keys[23].pressed) d = d - 10;
  kamera.aktual();
};

free(vcon);
stopscan();
modvga(0x3);
}