
struct rgb24 {
  long sirka, vyska;
  rgb *pixels;
};

struct rgbpic {
  long sirka, vyska;
  unsigned char *pixels;
  long barvy;
  rgbs *colors;
};

struct bmpfh {
  char password1;
  char password2;
  long filesize;
  int reserved1;
  int reserved2;
};

struct bmpi {
  char biheader;
  char bicolors;
  int neznama;
};

struct bmpih {
  long biseze;
  long sirka;
  long vyska;
  int planes;
  int bitcount;
  long compresion;
  long sizeimage;
  long xr;
  long yr;
  long colorused;
  long colimportant;
};

void bmpfree(rgbpic *obr) {
  free((*obr).colors);
  free((*obr).pixels);
}

void bmpfree(rgb24 *obr) {
  free((*obr).pixels);
}

void bmpread(char* soubor, rgbpic *obr) {
  FILE *f;
  int i = 0, x, y;
  long color;
  bmpfh hlavicka;
  bmpi info;
  bmpih infohlavicka;

  f = fopen(soubor, "rb");
  if (f != NULL) {

	fread((void *)&hlavicka, sizeof(bmpfh), 1, f);
	fread((void *)&info, sizeof(bmpi), 1, f);
	fread((void *)&infohlavicka, sizeof(bmpih), 1, f);
	color = infohlavicka.colorused;
	if (color == 0) color = 1 << infohlavicka.bitcount;
//	infohlavicka.sirka += 2;
//	infohlavicka.vyska ;

	(*obr).colors = (rgbs*)malloc(sizeof(rgbs)*color);
	if ((*obr).colors == NULL) {
	  modvga(0x3);
	  printf("Malo pameti\n");
	  exit (1);
	}
	(*obr).pixels = (unsigned char*)malloc(sizeof(unsigned char)*infohlavicka.sirka*infohlavicka.vyska);
	if ((*obr).pixels == NULL) {
	  modvga(0x3);
	  printf("Malo pameti\n");
	  exit (1);
	}

	fread((void *)(*obr).colors, sizeof(rgbs), color, f);
	fread((void *)(*obr).pixels, sizeof(unsigned char), infohlavicka.sirka*infohlavicka.vyska, f);

	fclose(f);

	(*obr).barvy = color;
	(*obr).sirka = infohlavicka.sirka;
	(*obr).vyska = infohlavicka.vyska;
  }
}

void bmpread(char* soubor, rgb24 *obr) {
  FILE *f;
  int i = 0, x, y;
  bmpfh hlavicka;
  bmpi info;
  bmpih infohlavicka;

  f = fopen(soubor, "rb");
  if (f != NULL) {

	fread((void *)&hlavicka, sizeof(bmpfh), 1, f);
	fread((void *)&info, sizeof(bmpi), 1, f);
	fread((void *)&infohlavicka, sizeof(bmpih), 1, f);

	(*obr).pixels = (rgb *)malloc(sizeof(rgb)*infohlavicka.sirka*infohlavicka.vyska);
	if ((*obr).pixels == NULL) {
	  modvga(0x3);
	  printf("Malo pameti\n");
	  exit (1);
	}

	fread((void *)(*obr).pixels, sizeof(rgb), infohlavicka.sirka*infohlavicka.vyska, f);

	fclose(f);

	(*obr).sirka = infohlavicka.sirka;
	(*obr).vyska = infohlavicka.vyska;
  }
}


void printbmp8(rgbpic *obr, int sx, int sy) {
  int i, x, y, b;

  for (i = 0; i < (*obr).barvy; i++)
	setpal6(i, (*obr).colors[i].r/4, (*obr).colors[i].g/4, (*obr).colors[i].b/4);
  for (x = 0; x < (*obr).sirka; x++) {
	for (y = 0; y < (*obr).vyska; y++) {
	  b = (*obr).pixels[x+y*(*obr).sirka];
	  pix(x + sx, (*obr).vyska - y + sy, b);
	}
  }
}

/*
void printbmp(rgbpic *obr, int sx, int sy) {
  struct palettetype pal;
  int i, x, y, b;

  getpalette(&pal);
  for (i = 0; i < (*obr).barvy; i++)
	setrgbpalette(pal.colors[i], (*obr).colors[i].r/4, (*obr).colors[i].g/4, (*obr).colors[i].b/4);
  for (x = 0; x < (*obr).sirka; x++) {
	for (y = 0; y < (*obr).vyska; y++) {
	  b = (*obr).pixels[x+y*(*obr).sirka];
	  putpixel(x + sx, (*obr).vyska - y + sy, b);
	}
  }
}
*/

void bmpvmem(int x0, int y0, char* soubor) {
  FILE *f;
  unsigned long i = 0, x, y;
  unsigned char b, g, r, c;
  bmpfh hlavicka;
  bmpi info;
  bmpih infohlavicka;

  f = fopen(soubor, "rb");
  if (f != NULL) {

	fread((void *)&hlavicka, sizeof(bmpfh), 1, f);
	fread((void *)&info, sizeof(bmpi), 1, f);
	fread((void *)&infohlavicka, sizeof(bmpih), 1, f);
	x = 0;
	y = infohlavicka.vyska;
	do {
	  b = getc(f);
	  g = getc(f);
	  r = getc(f);
	  pixsvga(x + x0, y + y0, r, g, b);
	  x ++;
	  if (x >= infohlavicka.sirka) { x = 0; y --;}
	} while(y > 0);

	fclose(f);
  }
}
