#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "vga.h"
#include "mys.h"

typedef float tip;

struct bodvektor {
  tip x, y;
  tip vx, vy;
  unsigned int vaha;
};

const poc = 50;
bodvektor provaz[100];

bodvektor rychlost(bodvektor b1, bodvektor b2, tip pruznost, tip vzdbod, tip treni) { // smerem k b1
  tip ax, ay, a, vx, vy, v, alfa;
  vx = (b1.x - b2.x);
  vy = (b1.y - b2.y);
  v = sqrt(vx*vx + vy*vy);

  a = (v-vzdbod)*pruznost/b2.vaha;
  if (a > 10) a = 10;
  if (a < -2) a = -2;
  if (v != 0) {
	alfa = a/v;
	ax = vx * alfa;
	ay = vy * alfa;
  }
  b2.vx += ax - b2.vx*treni;
  b2.vy += ay - b2.vy*treni;
  return(b2);
}

void prepocti(bodvektor p[], int poc, tip treni, tip pruznost, tip vzdbod) {

  int i = 0;

  if (poc == 2) {
	p[0] = rychlost(p[1], p[0], pruznost, vzdbod, treni);
	p[1] = rychlost(p[0], p[1], pruznost, vzdbod, treni);
  }

  if (poc > 2) {

	p[0] = rychlost(p[1], p[0], pruznost, vzdbod, treni);
	for(i = 1; i < poc-1; i++) {
	  p[i] = rychlost(p[i-1], p[i], pruznost, vzdbod, treni);
	  p[i] = rychlost(p[i+1], p[i], pruznost, vzdbod, treni);
	}
	p[poc-1] = rychlost(p[poc-2], p[poc-1], pruznost, vzdbod, treni);
  }
};

void posun(bodvektor p[], int poc) {
  int i = 0;
  for(i = 0; i < poc; i++) {
	p[i].x += p[i].vx;
	p[i].y += p[i].vy;
  }
}

void omez(bodvektor p[], int poc, int max) {
  tip v = 0;
  int i = 0;
  for(i = 0; i < poc; i++) {
	v = sqrt(p[i].vx*p[i].vx + p[i].vy*p[i].vy);
	if (v > max) {
	  p[i].vx = max/v * p[i].vx;
	  p[i].vy = max/v * p[i].vy;
	}
  }
}


void gravitace(bodvektor p[], int poc, tip g) {
  int i = 0;
  for(i = 0; i < poc; i ++) {
	p[i].vy += g;
  }
}

void vykresli(bodvektor p[], int poc, char b1, char b2) {
  int i = 0;
  char b = 0;
  for (i = 0; i < poc-1; i ++) {
	if (b == 0) setcolor(b1);
	if (b == 1) setcolor(b2);
	line((int)p[i].x, (int)p[i].y, (int)p[i+1].x, (int)p[i+1].y);
	b++;
	if (b > 1
	) b = 0;
  }
}

void main(void)
{
  initvga(1);

  tip treni = 0.01;
  tip pruznost = 2;
  tip vzdbod = 2;
  int max = 4;
  tip g = 0.01; //gravitacni zrychleni
  char barva1=14, barva2=12;
  short int drz, drzim1 = 0, drzim2 = 0, drzim3 = 0;
  tip dx = 100, dy = 100;
  char c = 0;

  int i = 0;
  for(i = 0; i <poc; i++) {
	provaz[i].x = 100;
	provaz[i].y = 100;
	provaz[i].vx = 0;
	provaz[i].vy = 0;
	provaz[i].vaha = 10;
  }
  provaz[0].vaha = 100;

  mouse mys;
  mys.set_off();
  mys.set_xy(100,100);

  while (c != 27) {
	swapactivep();
	delay(5);
	mys.aktual();
	cleardevice();
	prepocti(provaz, poc, treni, pruznost, vzdbod);
//	omez(provaz, poc, max);
	if (drzim3) {
	  gravitace(provaz, poc, g);
	}
	posun(provaz, poc);
	if (kbhit()) c = getch();
	if (c == 13) {
	  c = 0;
	  if (drzim1 == 0) drz = 1;
	  if (drzim1 == 1) drz = 0;
	  drzim1 = drz;
	}
	if (c == 'a') {
	  c = 0;
	  if (drzim2 == 0) drz = 1;
	  if (drzim2 == 1) drz = 0;
	  dx = provaz[poc-1].x;
	  dy = provaz[poc-1].y;
	  drzim2 = drz;
	}
	if (c == 'g') {
	  c = 0;
	  if (drzim3 == 0) drz = 1;
	  if (drzim3 == 1) drz = 0;
	  drzim3 = drz;
	}
	if (drzim1) {
	  provaz[0].x = mys.get_x();
	  provaz[0].y = mys.get_y();
	}
	if (drzim2) {
	  provaz[poc-1].x = dx;
	  provaz[poc-1].y = dy;
	}
	vykresli(provaz, poc, barva1, barva2);
	swapvisualp();
  }

  closegraph();
  closegraph();
}