
#define GRAN 65536
#define VMEMSEG 0xA0000000L
unsigned int chnga, chngb;
unsigned char far *vmem = (unsigned char far *)VMEMSEG;
unsigned long bytepos, pixpos;
unsigned int winpos;

struct rgb {
  unsigned char b;
  unsigned char g;
  unsigned char r;
};

struct rgbs {
  unsigned char b;
  unsigned char g;
  unsigned char r;
  unsigned char s;
};


struct modinfo {
  unsigned int xres, yres, bitpp; // rozliseni v x, v y, pocet bitu na pixel;
  unsigned int bytepp, bytepl;
  unsigned int a, b;
  unsigned int granw, sizew, segwa, segwb; // granularita okna v kB, velikost okna segment, segment zacatku okna
  unsigned int block, page; // pocet instalovanych bloku pameti po 64 kB, pocet stranek
  void (*func4f05h)(...);
}amod; // aktualni mod

void svgamodinfo(int mod, modinfo *mi) {
  typedef struct {
	unsigned int attrmod;
	unsigned char attrwa;
	unsigned char attrwb;
	unsigned int granularw;
	unsigned int sizew;
	unsigned int segwa;
	unsigned int segwb;
	void far *addr4f05h;
	unsigned int bitpscan;
	unsigned int xres;
	unsigned int yres;
	unsigned char charwidth;
	unsigned char charhigh;
	unsigned char planum;
	unsigned char bitpp;
	unsigned char banknum;
	unsigned char typmem;
	unsigned char banksize;
	unsigned char pagenum;
	unsigned char nonamed[226];
  }infos;
  infos info;
  unsigned int iseg = FP_SEG(&info);
  unsigned int iofs = FP_OFF(&info);
  asm {
	mov es, iseg
	mov di, iofs
	mov cx, mod
	mov ax, 0x4f01
	int 0x10
  }
  (*mi).xres = info.xres;
  (*mi).yres = info.yres;
  (*mi).bitpp = info.bitpp;
  (*mi).a = info.attrwa;
  (*mi).b = info.attrwb;
  (*mi).granw = info.granularw;
  (*mi).sizew = info.sizew;
  (*mi).segwa = info.segwa;
  (*mi).segwb = info.segwb;
  (*mi).page = info.pagenum;
  (*mi).func4f05h = (void (*)(...))info.addr4f05h;
  (*mi).bytepp = info.bitpp / 8;
  (*mi).bytepl = info.xres * (*mi).bytepp;
/*
printf("\n");
printf("attribut mod - %d\n", info.attrmod);
printf("attribut okna a - %d\n", info.attrwa);
printf("attribut okna b - %d\n", info.attrwb);
printf("granularita v kB - %d\n", info.granularw);
printf("adresa funkce 4f05 - %x \n", info.addr4f05h);
printf("velikost okna v kB- %d\n", info.sizew);
printf("segment okna a - %x\n", info.segwa);
printf("segment okna b - %x\n", info.segwb);
printf("bitu na scan radek - %d\n", info.bitpscan);
printf("rozliseni v x - %d\n", info.xres);
printf("rozliseni v y - %d\n", info.yres);
printf("sirka znaku - %d\n", info.charwidth);
printf("vyska znaku - %d\n", info.charhigh);
printf("pocet rovin - %d\n", info.planum);
printf("bitu na pixel - %d\n", info.bitpp);
printf("pocet bank - %d\n", info.banknum);
printf("typ pameti - %d\n", info.typmem);
printf("velikost banky - %d\n", info.banksize);
printf("pocet stranek - %d\n", info.pagenum);
getch();
*/
}

int svgainfo(modinfo *mi) {
  typedef struct {
	unsigned char vesaid[4];
	unsigned int verze;
	char far *infoptr;
	unsigned long undefine;
	unsigned int far *modeptr;
	unsigned int blocknum;
	unsigned char reserved[236];
  } infos;
  infos info;
  int vexist;
  unsigned int iseg = FP_SEG(&info);
  unsigned int iofs = FP_OFF(&info);
  asm {
	mov es, iseg
	mov di, iofs
	mov ax, 0x4f00
	int 0x10
	mov vexist, ax
  }
  (*mi).block = info.blocknum;
/*
printf("\n");
printf("vesa id - %s\n", info.vesaid);
printf("verze - %x\n", info.vesaid);
printf("info - %s\n", info.infoptr);
printf("undefine - %d\n", info.undefine);
printf("mody");

for (int i = 0; info.modeptr[i] != 0x0ffff; i++) {
  if ((i%5) == 0) printf("\n");
  printf("%xh - ", info.modeptr[i]);
}

printf("\n");
printf("pocet bloku - %d\n", info.blocknum);
*/
  if (vexist == 0x004f) return(1);
  else return(0);
}

void modsvga(int mod) {
  int test = 1;
  test = svgainfo(&amod);
  if (test == 1) {
	svgamodinfo(mod, &amod);
	asm {
	  mov ax, 0x4f02
	  mov bx, mod
	  int 0x10
	}
  }
}

void setwa(unsigned int granular) {
  asm {
	mov bl, 0x0
	mov dx, granular
  }
  amod.func4f05h();
}

void setwb(unsigned int granular) {
  asm {
	mov bl, 0x1
	mov dx, granular
  }
  amod.func4f05h();
}

inline void pixsvga(unsigned int x, unsigned int y, unsigned char r, unsigned char g, unsigned char b) {

  bytepos = (unsigned long)x*amod.bytepp + (unsigned long)y*amod.bytepl;

  winpos = bytepos/GRAN;
  pixpos = bytepos%GRAN;
  if (chnga != winpos) setwa(winpos);
  vmem[pixpos] = b;
  vmem[pixpos+1] = g;
  vmem[pixpos+2] = r;
  chnga = winpos;
}

inline gixsvga(unsigned int x, unsigned int y, rgb *bod) {
  bytepos = (unsigned long)x*amod.bytepp + (unsigned long)y*amod.bytepl;

  winpos = bytepos/GRAN;
  pixpos = bytepos%GRAN;
  if (chngb != winpos) setwb(winpos);
  (*bod).b = vmem[pixpos];
  (*bod).g = vmem[pixpos+1];
  (*bod).r = vmem[pixpos+2];
  chngb = winpos;
}

void getscann(void) {
  int bytepl, xres, yres;
  asm {
	mov ax, 0x4f06
	mov bl, 0x01
	int 0x10
	mov bytepl, bx
	mov xres, cx
	mov yres, dx
  }
  amod.bytepl = bytepl;
  amod.xres = xres;
  amod.yres = yres;
}

void setscann(int delka) {
  asm {
	mov ax, 0x4f06
	mov bx, 0x00
	mov cx, delka
	int 0x10
  }
  getscann();
}

void setvirtual(int x0, int y0) {
  asm {
	mov ax, 0x4f07
	mov bl, 0x00
	mov bh, 0x00
	mov cx, x0
	mov dx, y0
	int 0x10
	mov	dx,0x03da
  }
vertsinc:
  asm {
	in al,dx
	test al,8
	jz	vertsinc
  }
}

/*pomocne funkce*****/
void setpal6(int n,int r,int g,int b) {
 outp(0x3c8,n);
 outp(0x3c9,r);
 outp(0x3c9,g);
 outp(0x3c9,b);
}

void pix(int x, int y, int b) {
}

void modvga(int mod) {
  struct REGS reg;
  reg.h.ah = 0x00;
  reg.h.al = mod;
  int86(0x10, &reg, &reg);
}
/********************/